#include <stdio.h>
#include <allegro.h>

enum {
	SHEIGHT = 200,
	SWIDTH = 320,
	debug = 0
};

int main(int argc, char **argv) {
	BITMAP *bmp;
	FILE *fp;
	PALETTE pal;

	int i, j, c;
	char f[100];

	if (argc < 2) {
		fprintf(stderr, "usage: ben2bmp <.ben file>\n");
		exit(2);
	}

	if (!(fp = fopen(argv[1], "r"))) {
		perror(argv[1]);
		exit(3);
	}

	allegro_init();

	bmp = create_bitmap(SWIDTH, SHEIGHT);

	for (j=0; j<SHEIGHT; j++) {
		for (i=0; i<SWIDTH; i++) {
			fscanf(fp, "%d", &c);
			putpixel(bmp, i, j, c);
		}
	}
	fclose(fp);

	for (c=0; c<256; c++) {
		pal[c].r = ((c & 0xE0) >> 2) + 7;
		pal[c].g = ((c & 0x1C) << 1) + 7;
		pal[c].b = ((c & 0x3) << 4) + 15;
	}

	strcpy(f, argv[1]);
	f[strlen(f) - 1] = 'p';
	f[strlen(f) - 2] = 'm';

	save_bmp(f, bmp, pal);

	return 0;
	
}
