#include <stdio.h>
#include <stdarg.h>
#include "io.h"

enum {
	debug = 0
};

FILE *infile;

void currentfile(FILE *fp) {
	infile = fp;
}

void readin(char *s, void *f, char *format, ...) {
	va_list arg;
	char done;
	int check;
	char ch;

	done = 0;
	do {
		if (feof(infile)) {
			va_start(arg, format);
			fprintf(stderr, "Unexpected end of file.\nError reading ");
			vfprintf(stderr, format, arg);
			fprintf(stderr, "\n");
			va_end(arg);
			exit(1);
		}

		fscanf(infile, " %c", &ch);
		if (ch == '/') {
			parsecomment();
		} else {
			ungetc(ch, infile);
			check = fscanf(infile, s, f);
			if (!check) {
				va_start(arg, format);
				fprintf(stderr, "Error reading ");
				vfprintf(stderr, format, arg);
				fprintf(stderr, "\n");
				va_end(arg);
				exit(1);
			}

			if (debug) {
				va_start(arg, format);
				fprintf(stderr, "Read ");
				vfprintf(stderr, format, arg);
				fprintf(stderr, "\n");
				va_end(arg);
			}
			done++;
		}
	} while (!done);
}

void parsecomment(void) {
	char ch;
	char flag;

	ch = getc(infile);
	if (ch == '/') {
		while ((ch = getc(infile) != '\n'));
		return;
	} else if (ch != '*') {
		fprintf(stderr, "Warning: bad comment\n", ch);
	}
	flag = 0;
	do {
		do {
			ch = getc(infile);
		} while (ch != '*');
		if ((ch = getc(infile)) == '/') {
			flag++;
		}
	} while (!flag);
}
