#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <pc.h>
#include <sys/movedata.h>
#include <dpmi.h>
#include <time.h>

#define randomize() (srand((unsigned) time(NULL)))

typedef unsigned char byte;

// prototypes
void plot(int x, int y, byte c);
void plasma(int x1, int y1, int x2, int y2);
void c2rgb(byte c, byte rgb[3]);
byte rgb2c(byte rgb[3]);
byte randcolour(byte c, double a);

enum {
	swidth = 320,
	sheight = 200,
	picsize = 128,
	PALSIZE = 768
};

byte img[swidth * sheight];

int main() {
	byte c[3];
	int i, j;
	int addr;
	union REGS r;

	r.w.ax = 0x13;
	int86(0x10, &r, &r);

	outportb(0x3c8, 0);
	for (i=0; i<64; i++) {
		outportb(0x3c9, i);
		outportb(0x3c9, 0);
		outportb(0x3c9, i);
	}

	randomize();
	for (i=0; i<swidth * sheight; i++) img[i] = 0;

	img[0] = rand() % 64;
	img[picsize - 1] = rand() % 64;
	img[(picsize - 1) * swidth] = rand() % 64;
	img[(picsize - 1) * swidth + picsize - 1] = rand() % 64;
	plasma(0, 0, picsize-1, picsize-1);

	for (j=0; j<100; j++) {
		dosmemput(img, swidth * sheight, 0xA0000);
		img[0] += rand() % 3 - 1;
		img[picsize - 1] += rand() % 3 - 1;
		img[(picsize - 1) * swidth] += rand() % 3 - 1;
		img[(picsize - 1) * swidth + picsize - 1] += rand() % 3 - 1;
		plasma(0, 0, picsize-1, picsize-1);
	}

	getchar();

	r.w.ax = 3;
	int86(0x10, &r, &r);

	return(0);
}

void plasma(int x1, int y1, int x2, int y2) {
	byte c11, c12;
	byte c21, c22;
	byte c;
	int xm, ym;
	double xd;

	if (x2 - x1 <= 1 && y2 - y1 <= 1) return;
	c11 = img[y1 * swidth + x1];
	c12 = img[y2 * swidth + x1];
	c21 = img[y1 * swidth + x2];
	c22 = img[y2 * swidth + x2];

	xm = (x2 + x1) / 2;
	ym = (y2 + y1) / 2;

	xd = 1.0 * (x2 - x1) / picsize;
	xd *= xd;
	xd *= xd;
	xd *= 0.5;

	c = (c11 + c12 + c21 + c22) / 4;
	c = randcolour(c, xd);
	plot(xm, ym, c);
	c = (c11 + c12) / 2;
	c = randcolour(c, xd);
	plot(x1, ym, c);
	c = (c11 + c21) / 2;
	c = randcolour(c, xd);
	plot(xm, y1, c);
	c = (c21 + c22) / 2;
	c = randcolour(c, xd);
	plot(x2, ym, c);
	c = (c12 + c22) / 2;
	c = randcolour(c, xd);
	plot(xm, y2, c);
	plasma(x1, y1, xm, ym);
	plasma(xm, y1, x2, ym);
	plasma(x1, ym, xm, y2);
	plasma(xm, ym, x2, y2);
}

void c2rgb(byte c, byte rgb[3]) {
	rgb[0] = ((c & 0xE0) >> 2) + 7;
	rgb[1] = ((c & 0x1C) << 1) + 7;
	rgb[2] = ((c & 0x3) << 4) + 15;
}

byte rgb2c(byte rgb[3]) {
	byte c;

	c = ((rgb[0] & 0x38) << 2) + ((rgb[1] & 0x38) >> 1) + (rgb[2] >> 4);
	//printf("%d %d %d -> %d\n", rgb[0], rgb[1], rgb[2], c);
	return(c);
}

byte randcolour(byte c, double a) {
	int i;

	for (i=0; i<(10*a); i++) {
		if (c) c += (rand() % 3) - 1;
		if (c>63) c = 63;
	}
	return(c);

	//printf("%f\n", a);
	if (32 * a < 1) return(c);

	i = (rand() % (int) (32 * a)) - 16 + c;
	if (i<0) return(0);
	if (i>63) return(63);
	return((byte) i);

}

void plot(int x, int y, byte c) {
	img[y * swidth + x] = c;
}
