#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <pc.h>
#include "blin.h"
#include "yuck.h"

#define randomize() (srand((unsigned) time(NULL)))

enum {
	PALSIZE = 768
};

void initgraphics(void) {
	int i;
	byte c[3];
	union REGS r;

	r.w.ax = 0x13;
	int86(0x10, &r, &r);

	outportb(0x3c8, 0);
	for (i=0; i<256; i++) {
		c2rgb(i, c);
		outportb(0x3c9, c[0]);
		outportb(0x3c9, c[1]);
		outportb(0x3c9, c[2]);
	}
	return;

}

void settextmode(void) {
	union REGS r;

	r.w.ax = 3;
	int86(0x10, &r, &r);
}

void c2rgb(byte c, byte rgb[3]) {
	rgb[0] = ((c & 0xE0) >> 2) + 7;
	rgb[1] = ((c & 0x1C) << 1) + 7;
	rgb[2] = ((c & 0x3) << 4) + 15;
}

byte rgb2c(byte rgb[3]) {
	byte c;

	c = ((rgb[0] & 0x38) << 2) + ((rgb[1] & 0x38) >> 1) + (rgb[2] >> 4);
	//printf("%d %d %d -> %d\n", rgb[0], rgb[1], rgb[2], c);
	return(c);
}

byte prevcol(int n, byte c) {
	byte r;

	switch (n) {
		case 0:
			r = (((c & 0xE0) >> 5) - 1) << 5;
			r &= 0xE0;
			r += (c & ~0xE0);
			break;
		case 1:
			r = (((c & 0x1C) >> 2) - 1) << 2;
			r &= 0x1C;
			r += (c & ~0x1C);
			break;
		case 2:
			r = ((c & 3) - 1);
			r &= 3;
			r += (c & ~0x3);
			break;
	}
	return(r);
}

byte nextcol(int n, byte c) {
	byte r;

	switch (n) {
		case 0:
			r = (((c & 0xE0) >> 5) + 1) << 5;
			r &= 0xE0;
			r += (c & ~0xE0);
			break;
		case 1:
			r = (((c & 0x1C) >> 2) + 1) << 2;
			r &= 0x1C;
			r += (c & ~0x1C);
			break;
		case 2:
			r = ((c & 3) + 1);
			r &= 3;
			r += (c & ~0x3);
			break;
	}
	return(r);
}

void showmouse(void) {
	union REGS r;

	r.w.ax = 1;
	int86(0x33, &r, &r);
}

void pollmouse(mouse_event *e) {
	union REGS r;

	r.w.ax = 3;
	int86(0x33, &r, &r);
	e->x = r.w.cx / 2;
	e->y = r.w.dx;
	e->button = r.w.bx & 7;
}
